import { Player } from "./Player.js";


class MyPlayer extends Player
{
    constructor(client, pos, nb_goal, game, time)
    {
        super(client.me.id, pos, nb_goal, game);
        this.time = time;
        this.client = client;
    }    

    update_paddle(keys_pressed)
    {
        let new_pos = this.pos;

        if (keys_pressed.includes("s"))
            new_pos -= this.game.config.paddle_speed_per_second_max * this.time.deltaTimeSecond() * 1.0;
        if (keys_pressed.includes("w"))
            new_pos += this.game.config.paddle_speed_per_second_max * this.time.deltaTimeSecond() * 1.0;
        new_pos = Math.max(0 + this.game.config.paddle_ratio / 2, new_pos);
        new_pos = Math.min(1 - this.game.config.paddle_ratio / 2, new_pos);

        if (this.pos === new_pos)
            return;
        console.log(this.client.me.id)
        this.pos = new_pos;

        this.game._send_paddle(this.pos, this.time._current_frame);
    }

    update_pos(new_position, time)
    {
        let position_verified = new_position;

        let time_diff = (this.time._current_frame - time) / 1000;

        let sign = this - new_position >= 0 ? 1 : -1;

        let distance = Math.abs(this.pos - new_position);

        let distance_max = time_diff * this.game.config.paddle_speed_per_second_max;

        if (distance > distance_max)
            position_verified = distance_max * sign;

        this.pos = position_verified;
    }
}

export { MyPlayer }